.386
.model flat,stdcall
option casemap:none

include MBox.inc
    
.data
capt        db "Hello!",0
msg         db 'Customized message box',0
msg2        db 'Message box test',0
ButtonText  db 'Click here',0
bclass      db 'Button',0
    
.data?
    
pOldProc dd ?
    
.code
    
start:
    
    invoke  CustMsgBox,0,ADDR msg,ADDR capt,ADDR ButtonText
    invoke  ExitProcess,0
    
CustMsgBox  PROC uses esi handle:DWORD,message:DWORD,caption:DWORD,button:DWORD
    
LOCAL rc:RECT
LOCAL ThreadID:DWORD
LOCAL hWnd:DWORD
LOCAL hThread:DWORD
LOCAL buffer[100]
    
    invoke  CreateThread,0,0,ADDR ThreadProc,ADDR caption,0,ADDR ThreadID
    mov     hThread,eax
@@: 
    invoke  EnumWindows,ADDR EnumWndProc,ADDR ThreadID
    invoke  GetWindowText,hWnd,ADDR buffer,100
    invoke  StrCmpA,ADDR buffer,caption
    test    eax,eax
    jz      @b
    invoke  FindWindowEx,hWnd,0,ADDR bclass,0
    invoke  SetWindowText,eax,button
    invoke  GetWindowRect,hWnd,ADDR rc
    mov     ecx,rc.right
    sub     ecx,rc.left
    mov     edx,rc.bottom
    sub     edx,rc.top
    add     edx,20
    invoke  SetWindowPos,hWnd,0,0,0,ecx,edx,SWP_NOACTIVATE or SWP_NOMOVE
    invoke  GetModuleHandle,0
    invoke  LoadMenu,eax,IDM_MENU
    invoke  SetMenu,hWnd,eax
    invoke  SetWindowLong,hWnd,GWL_WNDPROC,ADDR MsgboxProc
    mov     pOldProc,eax
    invoke  WaitForSingleObject,hThread,INFINITE
    invoke  CloseHandle,hThread
    ret    
    
CustMsgBox ENDP
    
ThreadProc PROC pParams:DWORD
    
    mov     eax,pParams
    invoke  MessageBox,DWORD PTR [eax-8],DWORD PTR [eax-4],DWORD PTR [eax],MB_OK
    ret
    
ThreadProc ENDP
    
EnumWndProc PROC hWnd:DWORD,lParam:DWORD
    
    LOCAL pid:DWORD
    
    invoke  GetWindowThreadProcessId,hWnd,ADDR pid
    mov     edx,lParam
    cmp     eax,[edx]
    jne     @f
    push    hWnd
    pop     DWORD PTR [edx-4]  ; get the handle of the window
    xor     eax,eax            ; displaying the message box
    ret
@@:
    mov     eax,TRUE
    ret
    
EnumWndProc ENDP
    
MsgboxProc  PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    
    .IF uMsg == WM_COMMAND
    
        .IF wParam == IDB_EXIT
            invoke  SendMessage,hWnd,WM_CLOSE,0,0
    
        .ELSEIF wParam == IDB_ABOUT
            invoke  MessageBox,0,ADDR msg2,ADDR capt,MB_OK
    
        .ENDIF
    
    .ENDIF
    
    invoke  CallWindowProc,pOldProc,hWnd,uMsg,wParam,lParam
    ret
    
    MsgboxProc    ENDP

END start
